<?php

/**
 * @author Azamat Tokhtaev
 * @copyright 2007
 */

defined("_JEXEC") or die('Restricted Access');
jimport('joomla.event.plugin');

class plgSystemJSMassMail extends JPlugin
{

	var $_mailer   = null;

	var $_fromName = '';
	var $_mailfrom = '';
	var $_title  = '';
	var $_interval = 0;
	var $_body = '';
	var $_limit    = 0;


	function __construct(&$subject)
	{
		parent::__construct($subject);

		// load plugin parameters
		$this->_plugin = JPluginHelper::getPlugin('system', 'jsmassmail');
		$this->_params = new JParameter($this->_plugin->params);
	}

	function onAfterInitialise()
	{
		$db = &JFactory::getDBO();
		$this->checkNotStartedNewsletters();
		$id = JRequest::getVar('massmail', 0);
		if ($id)
		{
			$this->_updateEffectivness($id);
		}
		$sql = "SELECT nl.*  FROM #__jsmassmail_newsletters  as nl"
		." LEFT JOIN #__jsmassmail_users as u ON nl.id = u.letter_id "
		." WHERE nl.datestart < NOW()"
		." AND nl.started = 1"
		." AND nl.status = 'sending'"
		." GROUP BY (nl.id)";
		$db->setQuery($sql);

		$letters = $db->loadObjectList();
		foreach ($letters as $letter)
		{
			$this->_sendLetters($letter);
		}
	}


	function checkNotStartedNewsletters()
	{
		$db  = &JFactory::getDBO();
		$sql = "SELECT * FROM #__jsmassmail_newsletters WHERE `datestart` < NOW() AND `datestart` <> '0000-00-00 00:00:00' AND started = 0 AND `status` = 'sending'";
		$db->setQuery($sql);
		$letters = array();
		$letters = $db->loadObjectList();
		
		foreach ($letters as $letter)
		{
			$db->setQuery($letter->query);
			$users = $db->loadObjectList();

			if (count($users)>0)
			{
				$this->_addRecipients($users, $letter->id);
			}
			$sql = "UPDATE #__jsmassmail_newsletters SET `started` = 1 , `total` = ".count($users).", `status` = 'sending' WHERE `id` = {$letter->id}";
			$db->setQuery($sql);
			$db->query($sql);
		}
	}


	function _addRecipients(&$users , $id)
	{

		$db = &JFactory::getDBO();
		$total = count($users);
		if (count($users))
		{
			$query = "INSERT INTO #__jsmassmail_users (`user_id`, `letter_id`) VALUES ";
			foreach ($users as $key => $usr)
			{

				if ($key==$total-1)
				{
					$query.= " ( {$usr->id} , $id)";
				}
				else
				{
					$query.= " ( {$usr->id} , $id),";
				}
			}
			$db->setQuery($query);
			$db->query();

		}

	}

	function _sendLetters($letter)
	{
		$this->_title = $letter->title;

		$params = new JParameter($letter->params2);

		$interval = 0;
		$limit    = 0;

		if ($params->get('numtosend' , 0) != 0)
		{
			$limit = $params->get('numtosend');
		}

		if($params->get('sendinterval', 0)!=0)
		{
			$interval = $params->get('sendinterval');
		}

		$db = &JFactory::getDBO();
		$db->setQuery('SELECT NOW()');
		$time = $db->loadResult();
		$time_interval = strtotime("$time - $interval second");
		$lastSent = strtotime($letter->last_sent);
		if ($lastSent > $time_interval){
			return;
		}

		$limitstring = '';
		if ($limit > 0 )
		{
			$limitstring = "LIMIT {$limit}";
		}
		//Taking users from the database whom the newsletter will sent
		$sql = "SELECT u.name, u.email, u.id, u.username, u.usertype FROM #__jsmassmail_users as l"
		." INNER JOIN #__users AS u ON l.user_id = u.id "
		." WHERE l.letter_id = {$letter->id} ".$limitstring;
		$db->setQuery($sql);
		$users = $db->loadObjectList();
		//deleting users from the jsmassmail table in order not to accidentaly select them
		//several times (this happens only on high loaded web sites) But we have the
		//users in the variable so no need to worry he he.
		foreach ($users as $user)
		{
			$sql = "DELETE FROM #__jsmassmail_users WHERE `user_id` = {$user->id} AND `letter_id` = {$letter->id}";
			$db->setQuery($sql);
			$db->query();
		}
		//send the newsltter if we have more than one user to send.
		if (count($users)>0)
		{

			$pretext = $this->getMailEndText($letter->text, $letter->htmlortext );

            $config =& JFactory::getConfig();
            $sitename = $config->getValue('config.sitename');
            $siteurl = JURI::root();
            $pretext = preg_replace("/\[sitename\]/iU", $sitename, $pretext);
            $pretext = preg_replace("/\[siteurl\]/iU", $siteurl, $pretext);
            $pretext = preg_replace("/\[sitenameurl\]/iU", JHTML::link($siteurl, $sitename), $pretext);
            $pretext = preg_replace("/\[sitedescription\]/iU", $config->getValue('config.MetaDesc'), $pretext);

            $matches = array();
            $preg = '/href=\"http:\/\/'.preg_quote($_SERVER['HTTP_HOST']).'([^\"]*)\"|href=\"http:\/\/www\.'.preg_quote($_SERVER['HTTP_HOST']).'([^\"]*)\"/isU';
            preg_match_all($preg, $pretext, $matches);
            if ($matches[0]){
                foreach ($matches[0] as $key => $match)
                {
                    if(preg_match("/\?/iU", $matches[1][$key]))
                    {
                    	$newmatch = $match."&".'massmail='.$letter->id;
                    }
                    else
                    {
                    	$newmatch = $match."?".'massmail='.$letter->id;
                    }
                    
                    $pretext = str_replace($match, $newmatch, $pretext);
                }
            }
            $body = $pretext;
            
            //echo $body; die;
			foreach ($users as $user)
			{
				$mailer = $this->_initMailer($params);

				$this->_body = preg_replace("/\[name\]/iU", $user->name, $body);
				$this->_body = preg_replace("/\[username\]/iU", $user->username, $this->_body);
				$this->_body = preg_replace("/\[usertype\]/iU", $user->usertype, $this->_body);
				if (stripos($this->_body, '[confirmation]') !== false){
						//$this_user 		= clone(JFactory::getUser($user->id));
						jimport('joomla.user.helper');
						$code = JUtility::getHash( JUserHelper::genRandomPassword());
						//$this_user->set('activation', $code );
						$sql = "UPDATE #__users SET `activation` = '$code' WHERE `id` = ".$user->id;
						$db->setQuery($sql);
						if ( !$db->query() )
							{
								$cnfmsg = JText::_('To confirm email please ask site administrator');
							}
						else{
								$link = JURI::root().'index.php?option=com_jsmassmail&amp;task=confirm&amp;code='.$code.'&massmail='.$letter->id;
								$link_url = $link;
								$cnfmsg = JHTML::link($link, $link_url);
							}
						$this->_body = preg_replace("/\[confirmation\]/iU", $cnfmsg, $this->_body);
				}
				$this->_sendMail($mailer, $user->email, $letter->htmlortext);
			}
			//each time we send a letter we need to update the last send field
			//TO-DO: Maybe should be placed after all the letters were sent.
			$db->setQuery("UPDATE #__jsmassmail_newsletters SET `last_sent` = NOW() WHERE `id` = {$letter->id}");
			$db->query();
		}
		else if (count($users) == 0){
			$sql = "UPDATE #__jsmassmail_newsletters SET `started` = 0, `status` = 'sent' WHERE `id` = {$letter->id}";
			$db->setQuery($sql);
			$db->query($sql);
		}
	}

	function _initMailer($params)
	{

		$mailConfig = &JFactory::getConfig();
		if($params->get('type') != "global")
		{
			$mailConfig->setValue('config.mailer', $params->get('type'));
			$mailConfig->setValue('config.fromname', $params->get('fromname'));
			$mailConfig->setValue('config.mailfrom', $params->get('mailfrom'));
			$mailConfig->setValue('config.sendmail', $params->get('sendmail'));
			$mailConfig->setValue('config.smtpauth', $params->get('smtpauth'));
			$mailConfig->setValue('config.smtphost', $params->get('smtp_host'));
			$mailConfig->setValue('config.smtppass', $params->get('smtp_password'));
			$mailConfig->setValue('config.smtpuser', $params->get('smtp_username'));
		}


		jimport('phpmailer.phpmailer');
		jimport('joomla.mail.mail');

		$mailerOBJ = new JMail();

		$sendmail 	= $mailConfig->getValue('config.sendmail');
		$smtpauth 	= $mailConfig->getValue('config.smtpauth');
		$smtpuser 	= $mailConfig->getValue('config.smtpuser');
		$smtppass  	= $mailConfig->getValue('config.smtppass');
		$smtphost 	= $mailConfig->getValue('config.smtphost');
		$mailer 	= $mailConfig->getValue('config.mailer');

		$this->_mailfrom = $mailfrom 	= $mailConfig->getValue('config.mailfrom');
		$this->_fromName = $fromname 	= $mailConfig->getValue('config.fromname');




		$mailerOBJ->setSender(array ($mailfrom, $fromname));

		$mailerOBJ->ClearAttachments();
		$mailerOBJ->ClearAllRecipients();
		if ($params->get('attachment', 0) != 0 || $params->get('attachment', 0) != '')
		{
			$mailerOBJ->addAttachment($params->get('attachment'));
		}
		switch ($mailer)
		{
			case 'smtp' :
				$mailerOBJ->useSMTP($smtpauth, $smtphost, $smtpuser, $smtppass);
				break;
			case 'sendmail' :
				$mailerOBJ->IsSendmail();
				break;
			default :
				$mailerOBJ->IsMail();
				break;
		}

		return $mailerOBJ;
	}

	function _sendMail($mailer, $recipient, $mode=0)
	{
		$mail = $mailer;
		$mail->setSubject($this->_title);
		$mail->setBody($this->_body);
		if ( $mode ) {
			$mail->IsHTML(true);
		}
		$mail->addRecipient($recipient);

		return  $mail->Send();
	}

	function _updateEffectivness($id)
	{
		$db = &JFactory::getDBO();
		$sql = "UPDATE #__jsmassmail_newsletters SET `effectivness` = `effectivness` + 1 WHERE `id` = {$id}";
		$db->setQuery($sql);
		$db->query();

	}

	function getMailEndText( $text , $htmlortext = 1 )
	{


		$text = str_replace('"index.php',  '"'.JURI::root().'index.php',  $text);
		$text = str_replace('\'index.php', "'".JURI::root().'index.php', $text);
		$text = str_replace('\'plugins/joomsuite_content_fields', "'".JURI::root().'plugins/joomsuite_content_fields', $text);
		$text = str_replace('"plugins/joomsuite_content_fields', '"'.JURI::root().'plugins/joomsuite_content_fields', $text);

		if(!$htmlortext){
			$text = nl2br(strip_tags(str_replace(array('<br>','<br/>','<br />'), "\n", $text)));
		}
		return $text;
	}

}